/* attr.h - attribute interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef ATTR_H
#define ATTR_H

#include "strlist.h"

typedef enum {
  ATTR_NIL,
  ATTR_DEFAULT,
  ATTR_SINGLE,
  ATTR_MULTI
}               attr_state_t;

typedef struct {
  attr_state_t    state;
  uint32_t        acl;		/* offset to acl strlist_t */
  uint32_t        value;	/* offset to value strlist_t */
  uint32_t        content_type;	/* offset to content_type str_t */
  str_t           name;
}               attr_t;

#define attr_STATE(a) (ntohl((a)->state))
#define attr_ACL(a) ((strlist_t *)((caddr_t)&(a)->acl + ntohl((a)->acl)))
#define attr_VALUE(a) ((strlist_t *)((caddr_t)&(a)->value + ntohl((a)->value)))
#define attr_HAS_CTYPE(a) ((a)->content_type != 0)
#define attr_CTYPE(a) ((str_t *)((caddr_t)&(a)->content_type		\
				 + ntohl((a)->content_type)))
#define attr_NAME(a) (&(a)->name)

/* Attributes are only ever modified by the entry family of functions
 * in entry.c. */
#endif				/* ATTR_H */
