/* entry_ref_history.h--entry_ref_history interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef ENTRY_REF_HISTORY_H
#define ENTRY_REF_HISTORY_H

#include <pthread.h>
#include "stamp.h"
#include "../util/str.h"

typedef struct entry_ref_history_s entry_ref_history_t;

struct entry_ref_history_s {
  entry_ref_history_t *next;
  stamp_t         stamp;
  str_t          *db_path;
  dataset_key_t   key;
};

#define entry_ref_history_NEXT(w) ((w)->next)
#define entry_ref_history_STAMP(w) (&(w)->stamp)
#define entry_ref_history_DBPATH(w) ((w)->db_path)
#define entry_ref_history_DBKEY(w) ((w)->key)

#define entry_ref_history_SET_NEXT(w, n) ((w)->next = (n))
#define entry_ref_history_SET_DBKEY(w, k) ((w)->key = (k))

extern          result_t
entry_ref_history_alloc(stamp_t stamp,
			const str_t * db_path,
			dataset_key_t dataset_key,
			entry_ref_history_t ** dest);

extern result_t
                entry_ref_history_free(entry_ref_history_t ** history);

#define entry_ref_history_IS_YOUNGER(w, s)		\
	(stamp_LT(entry_ref_history_STAMP(w), s))
#endif				/* ENTRY_REF_HISTORY_H */
