/* daemon.h - general daemon interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef DAEMON_H
#define DAEMON_H

/* Initializes the base server modules. */
extern          result_t
                daemon_init(const char *prog_name);

/* Donates the main thread to the daemon, which proceeds to
 * start getting work done (this becomes the main IO handler thread) */
extern result_t daemon_run(void);

/* Tears down general daemon state */
extern result_t daemon_shutdown(void);

/* This handles unrecoverable errors. */
extern void
daemon_fatal(result_t err,
	     const char *format,...) __attribute__((noreturn,
						    format(printf, 2, 3)));

#endif				/* DAEMON_H */
